<div class="table-container mat-elevation-z8">
  <ng-scrollbar track="all">
    <mat-table [dataSource]="dataSource" multiTemplateDataRows matSort matSortActive="name" matSortDisableClear matSortDirection="asc" (matSortChange)="resetPaging()">

      <ng-container matColumnDef="name">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          <mat-icon class="">category</mat-icon>
          <span>Name</span>
        </mat-header-cell>
        <mat-cell *matCellDef="let element">{{ element.data.name }}</mat-cell>
      </ng-container>

      <ng-container matColumnDef="nbItems">
        <mat-header-cell *matHeaderCellDef mat-sort-header class="no-flex">
          <span>Items</span>
        </mat-header-cell>
        <mat-cell *matCellDef="let element" class="no-flex">{{ element.nbItems || 0 }}</mat-cell>
      </ng-container>

      <ng-container matColumnDef="actions">
        <mat-header-cell *matHeaderCellDef>
          <span>Actions</span>
          <button (click)="add()" mat-icon-button aria-label="Create new" class="new-item">
            <mat-icon>add</mat-icon>
          </button>
        </mat-header-cell>
        <mat-cell *matCellDef="let element">
          <div fxLayout="row" fxLayoutAlign="end">
            <button mat-icon-button aria-label="Open the edit form" (click)="openEditForm(element)">
              <mat-icon *ngIf="!element.expanded">edit</mat-icon>
              <mat-icon *ngIf="element.expanded">clear</mat-icon>
            </button>
            <button mat-icon-button [matMenuTriggerFor]="menu" aria-label="Open the action menu">
              <mat-icon>more_vert</mat-icon>
            </button>
            <mat-menu #menu="matMenu" xPosition="before">
              <button mat-menu-item (click)="delete(element)">
                <mat-icon color="warn">delete_forever</mat-icon>
                <span>Delete</span>
              </button>
            </mat-menu>
          </div>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="form">
        <mat-cell *matCellDef="let element" class="full-width">
          <div fxFlex="1 0 100%" fxLayout [class.expanded]="element.expanded">
            <ng-container *ngTemplateOutlet="form; context:{$implicit: element}"></ng-container>
          </div>
        </mat-cell>
      </ng-container>

      <mat-header-row @rowAnimation *matHeaderRowDef="displayedColumns; sticky: true"></mat-header-row>
      <mat-row @rowAnimation *matRowDef="let row; columns: displayedColumns;"></mat-row>
    </mat-table>
  </ng-scrollbar>
  <mat-paginator [length]="resultsLength" [pageSizeOptions]="pageSizeOptions" [pageSize]="pageSize"></mat-paginator>
</div>

<ng-template #form let-element>
  <form [formGroup]="element.form" (ngSubmit)="update(element)" fxFlex="1 0 100%" fxLayout>
    <div fxLayout="row" fxFlex="1 0 100%" fxLayoutAlign="start start" fxLayoutGap="16px" fxLayout.xs="column" fxLayoutAlign.xs="center stretch" fxLayoutGap.xs="0px">
      <ng-container *ngTemplateOutlet="formFields; context:{$implicit: element}"></ng-container>
      <div fxFlex="1 0" fxLayout fxLayoutAlign="end">
        <button type="submit" mat-raised-button color="primary" [disabled]="element.form.pristine || element.form.invalid">
          Update
        </button>
      </div>
    </div>
  </form>
</ng-template>

<ng-template #formFields let-element>
  <mat-tree [dataSource]="element.dataSource" [treeControl]="element.treeControl">
    <mat-nested-tree-node *matTreeNodeDef="let node" class="tree-node" #treeNode="matNestedTreeNode">
      <div fxLayout="row" fxLayoutGap="8px" fxLayoutAlign="start center">
        <div class="spacer" aria-hidden="true" *ngIf="treeNode.level >= 1"></div>
        <mat-form-field appearance="outline">
          <mat-label>Name *</mat-label>
          <input type="text" matInput [formControl]="node.controls.name">
        </mat-form-field>
        <mat-form-field appearance="outline">
          <mat-label>Shortname</mat-label>
          <input type="text" matInput [formControl]="node.controls.shortname">
        </mat-form-field>
        <button mat-icon-button aria-label="Add child" *ngIf="treeNode.level < 2" type="button" (click)="addChild(node, element)">
          <mat-icon>add</mat-icon>
        </button>
        <button mat-icon-button aria-label="Remove" color="warn" type="button" (click)="removeCategory(node, element)" *ngIf="treeNode.level > 0">
          <mat-icon>delete</mat-icon>
        </button>
      </div>
    </mat-nested-tree-node>
    <mat-nested-tree-node *matTreeNodeDef="let node; when: hasChild" class="tree-node" #treeNode="matNestedTreeNode">
      <div fxLayout="row" fxLayoutGap="8px" fxLayoutAlign="start center">
        <button *ngIf="treeNode.level >= 1" mat-icon-button [attr.aria-label]="'Toggle ' + node.value.name" matTreeNodeToggle type="button">
          <mat-icon class="mat-icon-rtl-mirror">
            {{ element.treeControl.isExpanded(node) ? 'expand_more' : 'chevron_right' }}
          </mat-icon>
        </button>
        <mat-form-field appearance="outline">
          <mat-label>Name *</mat-label>
          <input type="text" matInput [formControl]="node.controls.name">
        </mat-form-field>
        <mat-form-field appearance="outline">
          <mat-label>Shortname</mat-label>
          <input type="text" matInput [formControl]="node.controls.shortname">
        </mat-form-field>
        <button mat-icon-button aria-label="Add child" *ngIf="treeNode.level < 2" type="button" (click)="addChild(node, element)">
          <mat-icon>add</mat-icon>
        </button>
        <button mat-icon-button aria-label="Remove" color="warn" type="button" (click)="removeCategory(node, element)" *ngIf="treeNode.level > 0 && !hasChild(0, node)">
          <mat-icon>delete</mat-icon>
        </button>
      </div>
      <div [class.tree-node-invisible]="!element.treeControl.isExpanded(node)" fxLayout="column">
        <ng-container matTreeNodeOutlet></ng-container>
      </div>
    </mat-nested-tree-node>
  </mat-tree>
</ng-template>

<ng-template #addResourceDialog let-data let-ref="dialogRef">
  <h2 mat-dialog-title>
    <span *ngIf="!data.edit">Create a new category</span>
    <span *ngIf="data.edit">Edit "{{ data.form.value.name }}"</span>
  </h2>
  <form [formGroup]="data.form" (ngSubmit)="createOrUpdate(data, ref)">
    <mat-dialog-content fxLayout="column" fxLayoutGap="8px">
      <ng-container *ngTemplateOutlet="formFields; context:{$implicit: data}"></ng-container>
    </mat-dialog-content>
    <mat-dialog-actions>
      <button type="button" mat-button mat-dialog-close>Cancel</button>
      <button type="submit" mat-raised-button color="primary" [disabled]="data.form.pristine || data.form.invalid">
        <span *ngIf="!data.edit">Create</span>
        <span *ngIf="data.edit">Update</span>
      </button>
    </mat-dialog-actions>
  </form>
</ng-template>
